/* Linker control file for producing flux kernel image.
 * Portions based upon vmlinux.lds.
 *
 * Take advantage of Open Firmware to have ourselves loaded at the correct
 * address and avoid initial relocation (works on my Powerbook).
 *
 * Written by Jon Masters <jcm@jonmasters.org>
 *
 * Giant Panda got you down? Want a penguin instead? OH YES IT IS.
 */

OUTPUT_FORMAT("elf32-powerpc","elf32-powerpc","elf32-powerpc")
OUTPUT_ARCH("powerpc")
ENTRY(_start)
__DYNAMIC = 0;

SECTIONS
{
  . = + SIZEOF_HEADERS;
  .interp : { *(.interp) }
  .hash          : { *(.hash)		}
  .dynsym        : { *(.dynsym)		}
  .dynstr        : { *(.dynstr)		}
  .rel.text      : { *(.rel.text)		}
  .rela.text     : { *(.rela.text) 	}
  .rel.data      : { *(.rel.data)		}
  .rela.data     : { *(.rela.data) 	}
  .rel.rodata    : { *(.rel.rodata) 	}
  .rela.rodata   : { *(.rela.rodata) 	}
  .rel.got       : { *(.rel.got)		}
  .rela.got      : { *(.rela.got)		}
  .rel.ctors     : { *(.rel.ctors)	}
  .rela.ctors    : { *(.rela.ctors)	}
  .rel.dtors     : { *(.rel.dtors)	}
  .rela.dtors    : { *(.rela.dtors)	}
  .rel.bss       : { *(.rel.bss)		}
  .rela.bss      : { *(.rela.bss)		}
  .rel.plt       : { *(.rel.plt)		}
  .rela.plt      : { *(.rela.plt)		}
  .plt : { *(.plt) }

  .text          :
  {
     *(.text)
     __relocate_start = .;
     *(.got2)
     __relocate_end = .;
  }
  _etext = .;
  PROVIDE (etext = .);

  .rodata    : { *(.rodata) }

  .data      :
  {
     *(.data)
     *(.sdata)
     *(.sdata2)
  }
  _edata  =  .;
  PROVIDE (edata = .);

  __bss_start = .;
  .bss       :
  {
     *(.sbss)
     *(.bss)
  }
  _end = . ;
  PROVIDE (end = .);
  _flux_image_end = . ;
  PROVIDE (flux_image_end = .);
}
