/*
 * PowerPC CPU Initialisation Routines
 *
 * By Jon Masters <jcm@jonmasters.org>
 *
 */

#include <hal/ppc/ppc_table.h>
#include <kernel/kernel.h>

extern cpu_info_t cpu_table[CPU_MAX];

unsigned long cpu_init(unsigned long cpu_number) {

  if (cpu_number > CPU_MAX) {
    /* La la la la...we're fucked. */
    return CPU_INIT_ERROR_CPU_MAX;
  }

  if (cpu_table[cpu_number].status == CPU_STATUS_INIT_OK) {
    /* We are already initialised. */
    /*    BUG("Error at __FILE__, __LINE__"); */
    BUG();
  }

  __asm__ __volatile__ ("mfpvr %0"   : "=r" (cpu_table[cpu_number].pvr) );
  __asm__ __volatile__ ("mfmsr %0"   : "=r" (cpu_table[cpu_number].msr) );

  cpu_table[cpu_number].status = CPU_STATUS_INIT_OK;

  /* cpu_table[cpu_number].description = 0; */

  return CPU_INIT_OK;
}
