/*
 * Initial startup routines for Powermac systems such as the Powerbook G4.
 * This draws inspiration from the setup functions in Linux.
 *
 * By Jon Masters <jcm@jonmasters.org>
 *
 * This complements the individual head assembly files with C and inline asm.
 *
 * There are a whole host of issues here with this code though at the moment it
 * is only meant to run on a very specific Powerbook G4 MPC7455 667MHz laptop.
 *
 * This needs some cleanup.
 */

#include <const.h>
#include <hal/ppc/processor.h>
/* #include <hal/ofprom/prom.h> */
#include <hal/fbvideo/fbvideo_table.h>
#include <mm/mmu.h>

extern unsigned long _start;
extern unsigned long _end;

extern unsigned long reloc_offset();
extern void reloc_got2();
extern unsigned long prom_setup(int r3, int r4, int prom_client);
extern unsigned long cpu_init(unsigned long cpu_number);

extern fbvideo_info_t fbvideo_default;

/* This code now lives in bat_setup.c.
 * extern unsigned long fbvideo_BATU;
 * extern unsigned long fbvideo_BATL;
 * unsigned long system_BATU;
 * unsigned long system_BATL;
 */

extern void fbvideo_clear(unsigned long colour);
extern void fbvideo_write(const char *message);
extern void fbvideo_write_hex(unsigned long value);

extern void panic(void);

extern void sysinfo_display(void);

extern unsigned long ppc_mmu_disable(void);
extern void ppc_mmu_init_bats(void);
extern void ppc_mmu_init_htab(void);
extern void ppc_mmu_enable(void);

extern unsigned long physical_start_address;

unsigned long system_start_address;
unsigned long system_end_address;

unsigned long setup_pmac(int r3, int r4, int prom_client);
extern void setup_BATs(void);

unsigned long load_offset = 0; /* Chicken and egg problem. */

unsigned long setup_pmac(int r3, int r4, int prom_client) {

  unsigned long return_address = 0;
  unsigned long offset = reloc_offset();
  /* unsigned char colour = 0; */
  /* unsigned long old_msr = 0; */

  if (offset == 0) {
    /* Running at the link address already. */
    
  debug_offset:
    goto debug_offset;
    
    /* We are now expecting to be loaded by a bootloader such as yaboot in
       which case there is a requirement to relocate. Catch problems. */
    
  } else {

    reloc_got2(offset);
    load_offset = offset;
    
  }

  cpu_init(0); /* Initialise CPU 0 which we assume is the only one. */

  prom_setup(r3,r4,prom_client);

  /* for (colour=0; colour < 256; colour++) {
   * fbvideo_clear((unsigned long)(0x00|colour<<8|colour<<16|colour<<24));
   * }
   */

  system_start_address = (unsigned long)(&_start);
  system_end_address   = (unsigned long)(&_end);

  fbvideo_clear(0x00000000UL);

  fbvideo_write("Running Flux test code...\n\n");

  flux_main();
}
