/*
 * Framebuffer table header definitions.
 *
 * By Jon Masters <jcm@jonmasters.org>
 *
 */

#ifdef FBVIDEO_TABLE_H
#error You should only include fbvideo_table.h once!
#else
#define FBVIDEO_TABLE_H
#endif

#define FBVIDEO_DISPLAY_MAX  1

#define FBVIDEO_DISPLAY_ZERO 0

#define FBVIDEO_NAME_MAX_LENGTH 255

typedef struct {
  char name[FBVIDEO_NAME_MAX_LENGTH];
  unsigned long width;
  unsigned long height;
  unsigned long depth;
  unsigned long linebytes;
  unsigned long address;
  unsigned long virtual;

  unsigned long enabled;
  
  unsigned long X;
  unsigned long Y;
  unsigned long X_limit;
  unsigned long Y_limit;
  
  unsigned long background_colour;
  unsigned long foreground_colour;
} fbvideo_info_t;

