/*
 * Copyright (C) 2003 Jon Masters <jcm@jonmasters.org>.
 *
 * Memory Management PowerPC defines.
 */

#ifdef PPC_MM_H
#error You should only include hal/ppc/mm.h once!
#else
#define PPC_MM_H
#endif

/* Defines for PowerPC Specific data sizes. These relate only to those
 * implementation which conform to the PowerPC standard specification.
 * Other implementations use data structures of various sizes and software
 * assist routines to do TLB translations of page table walking (e.g. IBM 405).
 * Giant pandas will take over the world very soon now.
 */

#define PAGE_SIZE     0x1000              /* 4K pages. */
#define PAGE_SHIFT    12                  /* 12 bits. */
#define PAGE_OFFSET   0xC0000000          /* kernel offset. */

/* PowerPC Hash Table Information. */

#define HTAB_BASE       0xC0400000        /* Fixed address. */
#define HTAB_HPTEG_SIZE 6                 /* 64 bytes. */
#define HTAB_HPTEG_NUM  4096              /* 512K HTAB. */

