/*
 * PowerPC Memory Management architecture defines used by Flux.
 *
 * Copyright (C) 2003 Jon Masters <jcm@jonmasters.org>.
 *
 */

/* Some defines for the 32bit PowerPC BATs - see page 426 PowerPC Book III.
 */

/* BAT Lengths. */

#define BAT32_LENGTH_128KB 0x000<<2
#define BAT32_LENGTH_256KB 0x001<<2
#define BAT32_LENGTH_512KB 0x003<<2
#define BAT32_LENGTH_1MB   0x007<<2
#define BAT32_LENGTH_2MB   0x00F<<2
#define BAT32_LENGTH_4MB   0x01F<<2
#define BAT32_LENGTH_8MB   0x03F<<2
#define BAT32_LENGTH_16MB  0x07F<<2
#define BAT32_LENGTH_32MB  0x0FF<<2
#define BAT32_LENGTH_64MB  0x1FF<<2
#define BAT32_LENGTH_128MB 0x3FF<<2
#define BAT32_LENGTH_256MB 0x7FF<<2

/* Supervisor state valid bit. */

#define BAT32_VS           0x2

/* BAT WIMG. */

#define BAT32_WIMG_W       0x008
#define BAT32_WIMG_I       0x004
#define BAT32_WIMG_M       0x002
#define BAT32_WIMG_G       0x001

/* BAT PP. */

#define BAT32_PP_NONE      0x00
#define BAT32_PP_RX        0x01
#define BAT32_PP_RW        0x02

