/*
 * Copyright (C) 2003 Jon Masters <jcm@jonmasters.org>
 *
 */

#include <kernel/misc/string.h>

/***************************** GLOBAL VARIABLES *****************************/

char *strcpy(char *destination, const char *source);
char *strncpy(char *destination, const char *source, unsigned long size);

unsigned long strlen(const char *string);

char *strcpy(char *destination, const char *source) {

  strncpy(destination, source, strlen(source));

  return destination;

}

unsigned long strlen(const char *string) {

  unsigned long length = 0;

  char *string_ptr = (char *)0;

  for (string_ptr = (char *)string; *string_ptr != '\0'; length++) {
    string_ptr++;
  }

  return length;

}

char *strncpy(char *destination, const char *source, unsigned long size) {

  unsigned long length = 0;

  char *string_ptr = (char *)0;

  for (string_ptr = (char *)source; ((*string_ptr != '\0') && (length < size));
	 length++, string_ptr++) {
    destination[length] = source[length];
  }

  return destination;

}

void *memcpy(void *destination, const void *source, unsigned long size) {

  unsigned long length           = 0;
  unsigned long *memory_ptr      = (unsigned long *)0;
  unsigned long *source_ptr      = (unsigned long *)source;
  unsigned long *destination_ptr = (unsigned long *)destination;
  
  for (memory_ptr = source_ptr; length < size; length++, memory_ptr++) {
    destination_ptr[length] = source_ptr[length];
  }

  return destination;

}

void *memset(unsigned long *destination, int value, unsigned long size) {

  unsigned long *limit      = 0;

  for (limit=destination+size;limit>=destination;limit--) {
    destination[0] = value;
  }

  return destination;

}
